set argv0 "terminal.exe"
package require http
package require tls
package require tdom
proc WriteLog { args } {
	set log [ open "log.txt" "a+" ]
	if { $log != {} } {
		puts $log [ join $args " " ]
	}
}
if [ catch {
::http::register https 443 ::tls::socket
} msg ] {
	WriteLog "tls not inited : $msg"
	return -code error "tcl error $msg"
}
set request ""
proc StartClient { repeate } {
	RequestJobs $repeate
}
proc StopClient {} {
	global request
	if { $request!="" } {
		catch { ::http::reset $request }
	}
}
proc RequestJobs { {repeate 15} {url "https://www.mql5.com/ru/job"} } {
	global request
	if { $request!="" } {
		catch { ::http::reset $request }
	}
	if [ catch {
		set request [ http::geturl $url -command [ list ProcessResponse $repeate $url ] ]
	} msg ] {
		# puts stderr "error in request:$msg"
		after [ expr $repeate * 60 * 1000 ] [ list RequestJobs $repeate $url ]
	}
}
proc ProcessResponse { repeate url token } {
	global request
	set request ""
	upvar #0 $token page
	if [ catch {
		if { $page(status)=="ok" } {
			set body $page(body)
			if { $body!="" } {
				global report
				set report [ ParseHtml $body ]
			}
		}
	} msg ] {
		# puts stderr "error in responce : $msg"
	}
	::http::cleanup $token
	after [ expr $repeate * 60 * 1000 ] [ list RequestJobs $repeate $url ]
}
proc ParseHtml { body } {
	set report {}
	# разобрать body в xml
	set doc [ dom parse -html $body ]
	#$doc normalize -forXPath
	# получить корень
	set root [ $doc documentElement ]
	# описания работ лежат внутри <div class="job-item"></div>
	set jobs [ $root selectNodes {//div[@class='job-item']} ]
	# сделать из них простые списки :-)
	foreach job $jobs {
		set titleNode [ lindex [ $job selectNodes {.//div[@class='job-item__title']} ] 0 ]
		if { $titleNode != {} } {
			set title [ string trim [ $titleNode asText ] ]
			set budgetNode [ lindex [ $job selectNodes {.//span[@class='budget']} ] 0 ]
			if { $budgetNode != {} } {
				set budget [ string trim [ $budgetNode asText ] ]
				lappend report [ format "%15s  |  %s" $budget $title ":" ]
			}
		}
	}
	if { $report != {} } {
		set report [ join $report "\n" ]
	}
	# отдать результат
	return $report
}
